/*
lqr.hh

This C++ header file defines the class LQR_MODULE
It was generated with the RCS-Design tool.
Template Version 1.1

MODIFICATIONS:
13-Sep-99	Created by RCS-Design tool.

*/

// Prevent Multiple Inclusion
#ifndef LQR_HH
#define LQR_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "lqr_ctrl.hh"  // LQR_CTRL definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "lqrn.hh" 	// NML Commands and Status definitions for lqr
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


class LQR_MODULE: public NML_MODULE
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

public:

	LQR_MODULE(int _is_base_class = 0); // Constructor

	// Overloaded Virtual Functions
	virtual void PRE_PROCESS();
	virtual void DECISION_PROCESS();
	virtual void POST_PROCESS();
	virtual void INITIALIZE_NML();

	// Command Functions
	virtual void INIT(LQR_INIT *);
	virtual void HALT(LQR_HALT *);
	virtual void RUN(LQR_RUN *);
	virtual void SET_GAINS(LQR_SET_GAINS *);

	// Convenience Variables
	LQR_STATUS *lqr_status;
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


private:
	// Add custom variables and functions here.
  int plant_order;
  LQR_CTRL *lqr_ctrl;
  double plant_state[PLANT_ORDER];
  double ctrl_output;

};

#endif 	// LQR_HH

